/**
 Trivial porthreads program, using assembly "lock" prefix.
 Orion Sky Lawlor, olawlor@acm.org, 2005/2/7 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include "osl/porthread.h"
#include "osl/porthread.cpp" /*<- for easier linking */

/* Describes a range of numbers to count */
struct number_range {
	int lo, hi;
};

int total_count=0;

void count_range(number_range *n) {
	for (int i=n->lo;i<n->hi;i++) 
		if ((i%2)==0) {
		#ifdef _WIN32 /* Windows x86 assembly */
			__asm { lock inc total_count };
		#else /* GCC x86 */
			__asm__ ("lock incl total_count");
		#endif
		}
}

int main() {
	number_range An;
	number_range Bn;
	An.lo=0;
	An.hi=Bn.lo=5000000;
	Bn.hi=10000000;
	
	porthread_t p=porthread_create((porthread_fn_t)count_range,&An);
	count_range(&Bn);
	porthread_wait(p);
	printf("Total count: %d\n",total_count);
	return 0;
}
